using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using System.Diagnostics;
using System.Text.RegularExpressions;


namespace CsCgrep
{
	/// <summary>
	/// CsCgrep̃CEBhEłB
	/// </summary>
	public class MainWindow : System.Windows.Forms.Form
	{
		/// <summary>
		/// ʃe[u̓ẽCfbNX
		/// </summary>
		public const int CONTENTS_COLUMN_INDEX = 3;

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem fileMenu;
		private System.Windows.Forms.MenuItem exitMenuItem;
		private System.Windows.Forms.ToolBar toolBar1;
		private System.Windows.Forms.ToolBarButton searchButton;
		private System.Windows.Forms.ToolBarButton separator1;
		private System.Windows.Forms.ToolBarButton cancelButton;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.CheckBox subFolderCheckBox;
		private System.Windows.Forms.CheckBox caseSensitiveCheckBox;
		private System.Windows.Forms.CheckBox regExCheckBox;
		private System.Windows.Forms.Button folderBrowseButton;
		private System.Windows.Forms.ComboBox searchPlaceBox;
		private System.Windows.Forms.ComboBox searchStringBox;
		private System.Windows.Forms.ComboBox fileNameBox;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.MenuItem helpMenu;
		private System.Windows.Forms.MenuItem versionMenuItem;
        private System.ComponentModel.IContainer components;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.NumericUpDown trailingLinesToPrintBox;
		private System.Windows.Forms.NumericUpDown leadingLinesToPrintBox;
		private System.Windows.Forms.NumericUpDown blankLineBetweenBlocksBox;
		private System.Windows.Forms.ImageList imageList1;
        private System.Windows.Forms.StatusBarPanel statusBarPanel1;
        private System.Windows.Forms.StatusBarPanel statusBarPanel2;
        private DataGridView dataGridView1;
        private Label label10;
        private System.Windows.Forms.ProgressBar progressBar1;
        private ContextMenuStrip contextMenuStrip1;
        private ToolStripMenuItem copyContextMenuItem;


		/// <summary>
		/// 
		/// </summary>
		private ArrayList searchResults = new ArrayList();

		/// <summary>
		/// ʃe[u
		/// </summary>
		private DataTable resultTable;

		/// <summary>
		/// AvP[Vݒ
		/// </summary>
        private ApplicationSettings applicationSettings;
        private DataGridViewTextBoxColumn fileName;
        private DataGridViewTextBoxColumn place;
        private DataGridViewTextBoxColumn lineNumber;
        private DataGridViewTextBoxColumn contents;
        private MenuItem resultOutputMenuItem;
        private ToolBarButton separator2;
        private ToolBarButton outputButton;
        private MenuItem encodingMenuItem;
        private MenuItem inputEncodingMenuItem;
        private MenuItem inputSjisMenuItem;
        private MenuItem outputEncodingMenuItem;
        private MenuItem inputUtf8MenuItem;
        private MenuItem inputEucMenuItem;
        private MenuItem outputSjisMenuItem;
        private MenuItem outputUtf8MenuItem;
        private MenuItem outputEucMenuItem;
        private MenuItem toolMenu;
        private MenuItem settingMenuItem;
        private Label label11;
        private Label outputLineCount;
        private Label label13;
        private Label label12;

		/// <summary>
		/// sXbh
		/// </summary>
		private Thread searchThread;

		/// <summary>
		/// Xe[^Xo[̃eLXgݒfQ[g
		/// </summary>
		private delegate void SetStatusBarTextDelegate(string s);

        /// <summary>
        /// ̎擾fQ[g
        /// </summary>
        /// <returns></returns>
        private delegate string GetSearchStringDelegate();

        /// <summary>
        /// ꏊ̎擾fQ[g
        /// </summary>
        /// <returns></returns>
        private delegate string GetSearchPlaceDelegate();

        /// <summary>
        /// Ώۂ̃t@C̎擾fQ[g
        /// </summary>
        /// <returns></returns>
        private delegate string GetSearchFileNameDelegate();

        /// <summary>
        /// TutH_̌L̎擾fQ[g
        /// </summary>
        /// <returns></returns>
        private delegate bool IsSearchSubFolderDelegate();

		/// <summary>
		/// p[^ݒfQ[g
		/// </summary>
		private delegate void SetSearchParameterDelegate(Cgrep cgrep);

		/// <summary>
		/// ʒǉfQ[g
		/// </summary>
		private delegate void AddSearchResultDelegate(SearchResult r);

        /// <summary>
        /// }b`sFύXfQ[g
        /// </summary>
        private delegate void ChangeMatchingLinesDelegate();

		/// <summary>
		/// e{^ԐݒfQ[g
		/// </summary>
		private delegate void SetButtonStateDelegate();

		/// <summary>
		/// vOXo[̍őŏݒfQ[g
		/// </summary>
		private delegate void SetMinimumAndMaximumOfProgressBarDelegate(int min, int max);

		/// <summary>
		/// vOXo[̌ݒlݒfQ[g
		/// </summary>
		private delegate void SetCurrentValueOfProgressBarDelegate(int v);

		/// <summary>
		/// vOXo[̌ݒl𑝂₷fQ[g
		/// </summary>
		private delegate void IncrementProgressBarDelegate(int v);

		/// <summary>
		/// f[^ObhɃf[^e[uAfQ[g
		/// </summary>
		private delegate void BindDataTableDelegate(DataTable dt);

		/// <summary>
		/// f[^Obh̃JTCYfQ[g
		/// </summary>
		private delegate void AutoSizeColumnWidthDelegate();

        /// <summary>
        /// ʈꗗ̍XV~fQ[g
        /// </summary>
        private delegate void StartResultUpdateDelegate();

        /// <summary>
        /// ʈꗗ̍XVĊJfQ[g
        /// </summary>
        private delegate void StopResultUpdateDelegate();

        /// <summary>
        /// ʈꗗ̃Z̑INAfQ[g
        /// </summary>
        private delegate void ClearCellSelectionDelegate();

        /// <summary>
        /// ʈꗗ̃Z̃\[gsɐݒ肷fQ[g
        /// </summary>
        private delegate void SetNotSortableDelegate();

        /// <summary>
        /// ʈꗗ̏o͍sݒ肷fQ[g
        /// </summary>
        /// <param name="count">o͍s</param>
        private delegate void SetOutputLineCountDelegate(int count);

		/// <summary>
		/// 
		/// </summary>
		public ArrayList SearchResults
		{
			get
			{
				return searchResults;
			}
		}

        /// <summary>
        /// AvP[Vݒ
        /// </summary>
        public ApplicationSettings AppSettings
        {
            get
            {
                return applicationSettings;
            }
        }

		public MainWindow()
		{
			//
			// Windows tH[ fUCi T|[gɕKvłB
			//
			InitializeComponent();

			// f[^Obh̏
			InitializeDataGrid();

			applicationSettings = new ApplicationSettings();
		}

		/// <summary>
		/// gpĂ郊\[XɌ㏈s܂B
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows tH[ fUCiŐꂽR[h 
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		private void InitializeComponent()
		{
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(MainWindow));
            this.mainMenu1 = new System.Windows.Forms.MainMenu(this.components);
            this.fileMenu = new System.Windows.Forms.MenuItem();
            this.resultOutputMenuItem = new System.Windows.Forms.MenuItem();
            this.encodingMenuItem = new System.Windows.Forms.MenuItem();
            this.inputEncodingMenuItem = new System.Windows.Forms.MenuItem();
            this.inputSjisMenuItem = new System.Windows.Forms.MenuItem();
            this.inputUtf8MenuItem = new System.Windows.Forms.MenuItem();
            this.inputEucMenuItem = new System.Windows.Forms.MenuItem();
            this.outputEncodingMenuItem = new System.Windows.Forms.MenuItem();
            this.outputSjisMenuItem = new System.Windows.Forms.MenuItem();
            this.outputUtf8MenuItem = new System.Windows.Forms.MenuItem();
            this.outputEucMenuItem = new System.Windows.Forms.MenuItem();
            this.exitMenuItem = new System.Windows.Forms.MenuItem();
            this.toolMenu = new System.Windows.Forms.MenuItem();
            this.settingMenuItem = new System.Windows.Forms.MenuItem();
            this.helpMenu = new System.Windows.Forms.MenuItem();
            this.versionMenuItem = new System.Windows.Forms.MenuItem();
            this.toolBar1 = new System.Windows.Forms.ToolBar();
            this.searchButton = new System.Windows.Forms.ToolBarButton();
            this.separator1 = new System.Windows.Forms.ToolBarButton();
            this.cancelButton = new System.Windows.Forms.ToolBarButton();
            this.separator2 = new System.Windows.Forms.ToolBarButton();
            this.outputButton = new System.Windows.Forms.ToolBarButton();
            this.imageList1 = new System.Windows.Forms.ImageList(this.components);
            this.label1 = new System.Windows.Forms.Label();
            this.label2 = new System.Windows.Forms.Label();
            this.label3 = new System.Windows.Forms.Label();
            this.searchPlaceBox = new System.Windows.Forms.ComboBox();
            this.searchStringBox = new System.Windows.Forms.ComboBox();
            this.fileNameBox = new System.Windows.Forms.ComboBox();
            this.subFolderCheckBox = new System.Windows.Forms.CheckBox();
            this.caseSensitiveCheckBox = new System.Windows.Forms.CheckBox();
            this.regExCheckBox = new System.Windows.Forms.CheckBox();
            this.folderBrowseButton = new System.Windows.Forms.Button();
            this.groupBox1 = new System.Windows.Forms.GroupBox();
            this.trailingLinesToPrintBox = new System.Windows.Forms.NumericUpDown();
            this.leadingLinesToPrintBox = new System.Windows.Forms.NumericUpDown();
            this.label8 = new System.Windows.Forms.Label();
            this.label7 = new System.Windows.Forms.Label();
            this.label6 = new System.Windows.Forms.Label();
            this.label5 = new System.Windows.Forms.Label();
            this.label4 = new System.Windows.Forms.Label();
            this.label9 = new System.Windows.Forms.Label();
            this.groupBox2 = new System.Windows.Forms.GroupBox();
            this.blankLineBetweenBlocksBox = new System.Windows.Forms.NumericUpDown();
            this.statusBar = new System.Windows.Forms.StatusBar();
            this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
            this.statusBarPanel2 = new System.Windows.Forms.StatusBarPanel();
            this.progressBar1 = new System.Windows.Forms.ProgressBar();
            this.dataGridView1 = new System.Windows.Forms.DataGridView();
            this.fileName = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.place = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.lineNumber = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.contents = new System.Windows.Forms.DataGridViewTextBoxColumn();
            this.contextMenuStrip1 = new System.Windows.Forms.ContextMenuStrip(this.components);
            this.copyContextMenuItem = new System.Windows.Forms.ToolStripMenuItem();
            this.label10 = new System.Windows.Forms.Label();
            this.label11 = new System.Windows.Forms.Label();
            this.outputLineCount = new System.Windows.Forms.Label();
            this.label13 = new System.Windows.Forms.Label();
            this.label12 = new System.Windows.Forms.Label();
            this.groupBox1.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.trailingLinesToPrintBox)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.leadingLinesToPrintBox)).BeginInit();
            this.groupBox2.SuspendLayout();
            ((System.ComponentModel.ISupportInitialize)(this.blankLineBetweenBlocksBox)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).BeginInit();
            ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).BeginInit();
            this.contextMenuStrip1.SuspendLayout();
            this.SuspendLayout();
            // 
            // mainMenu1
            // 
            this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.fileMenu,
            this.toolMenu,
            this.helpMenu});
            // 
            // fileMenu
            // 
            this.fileMenu.Index = 0;
            this.fileMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.resultOutputMenuItem,
            this.encodingMenuItem,
            this.exitMenuItem});
            this.fileMenu.Text = "t@C(&F)";
            // 
            // resultOutputMenuItem
            // 
            this.resultOutputMenuItem.Index = 0;
            this.resultOutputMenuItem.Text = "ʂt@Cɏo(&O)...";
            this.resultOutputMenuItem.Click += new System.EventHandler(this.resultOutputMenuItem_Click);
            // 
            // encodingMenuItem
            // 
            this.encodingMenuItem.Index = 1;
            this.encodingMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.inputEncodingMenuItem,
            this.outputEncodingMenuItem});
            this.encodingMenuItem.Text = "R[h(&C)";
            // 
            // inputEncodingMenuItem
            // 
            this.inputEncodingMenuItem.Index = 0;
            this.inputEncodingMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.inputSjisMenuItem,
            this.inputUtf8MenuItem,
            this.inputEucMenuItem});
            this.inputEncodingMenuItem.Text = "";
            // 
            // inputSjisMenuItem
            // 
            this.inputSjisMenuItem.Checked = true;
            this.inputSjisMenuItem.Index = 0;
            this.inputSjisMenuItem.RadioCheck = true;
            this.inputSjisMenuItem.Text = "{ (Vtg JIS)";
            this.inputSjisMenuItem.Click += new System.EventHandler(this.inputSjisMenuItem_Click);
            // 
            // inputUtf8MenuItem
            // 
            this.inputUtf8MenuItem.Index = 1;
            this.inputUtf8MenuItem.RadioCheck = true;
            this.inputUtf8MenuItem.Text = "Unicode (UTF-8)";
            this.inputUtf8MenuItem.Click += new System.EventHandler(this.inputUtf8MenuItem_Click);
            // 
            // inputEucMenuItem
            // 
            this.inputEucMenuItem.Index = 2;
            this.inputEucMenuItem.RadioCheck = true;
            this.inputEucMenuItem.Text = "{ (EUC)";
            this.inputEucMenuItem.Click += new System.EventHandler(this.inputEucMenuItem_Click);
            // 
            // outputEncodingMenuItem
            // 
            this.outputEncodingMenuItem.Index = 1;
            this.outputEncodingMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.outputSjisMenuItem,
            this.outputUtf8MenuItem,
            this.outputEucMenuItem});
            this.outputEncodingMenuItem.Text = "o";
            // 
            // outputSjisMenuItem
            // 
            this.outputSjisMenuItem.Checked = true;
            this.outputSjisMenuItem.Index = 0;
            this.outputSjisMenuItem.RadioCheck = true;
            this.outputSjisMenuItem.Text = "{ (Vtg JIS)";
            this.outputSjisMenuItem.Click += new System.EventHandler(this.outputSjisMenuItem_Click);
            // 
            // outputUtf8MenuItem
            // 
            this.outputUtf8MenuItem.Index = 1;
            this.outputUtf8MenuItem.RadioCheck = true;
            this.outputUtf8MenuItem.Text = "Unicode (UTF-8)";
            this.outputUtf8MenuItem.Click += new System.EventHandler(this.outputUtf8MenuItem_Click);
            // 
            // outputEucMenuItem
            // 
            this.outputEucMenuItem.Index = 2;
            this.outputEucMenuItem.RadioCheck = true;
            this.outputEucMenuItem.Text = "{ (EUC)";
            this.outputEucMenuItem.Click += new System.EventHandler(this.outputEucMenuItem_Click);
            // 
            // exitMenuItem
            // 
            this.exitMenuItem.Index = 2;
            this.exitMenuItem.Text = "I(&X)";
            this.exitMenuItem.Click += new System.EventHandler(this.exitMenuItem_Click);
            // 
            // toolMenu
            // 
            this.toolMenu.Index = 1;
            this.toolMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.settingMenuItem});
            this.toolMenu.Text = "c[";
            // 
            // settingMenuItem
            // 
            this.settingMenuItem.Index = 0;
            this.settingMenuItem.Text = "IvV(&O)...";
            this.settingMenuItem.Click += new System.EventHandler(this.settingMenuItem_Click);
            // 
            // helpMenu
            // 
            this.helpMenu.Index = 2;
            this.helpMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.versionMenuItem});
            this.helpMenu.Text = "wv(&H)";
            // 
            // versionMenuItem
            // 
            this.versionMenuItem.Index = 0;
            this.versionMenuItem.Text = "o[W(&A)...";
            this.versionMenuItem.Click += new System.EventHandler(this.versionMenuItem_Click);
            // 
            // toolBar1
            // 
            this.toolBar1.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
            this.searchButton,
            this.separator1,
            this.cancelButton,
            this.separator2,
            this.outputButton});
            this.toolBar1.DropDownArrows = true;
            this.toolBar1.ImageList = this.imageList1;
            this.toolBar1.Location = new System.Drawing.Point(0, 0);
            this.toolBar1.Name = "toolBar1";
            this.toolBar1.ShowToolTips = true;
            this.toolBar1.Size = new System.Drawing.Size(852, 28);
            this.toolBar1.TabIndex = 0;
            this.toolBar1.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar1_ButtonClick);
            // 
            // searchButton
            // 
            this.searchButton.ImageIndex = 0;
            this.searchButton.Name = "searchButton";
            this.searchButton.ToolTipText = "s";
            // 
            // separator1
            // 
            this.separator1.Name = "separator1";
            this.separator1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // cancelButton
            // 
            this.cancelButton.Enabled = false;
            this.cancelButton.ImageIndex = 2;
            this.cancelButton.Name = "cancelButton";
            this.cancelButton.ToolTipText = "𒆎~";
            // 
            // separator2
            // 
            this.separator2.Name = "separator2";
            this.separator2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
            // 
            // outputButton
            // 
            this.outputButton.ImageIndex = 3;
            this.outputButton.Name = "outputButton";
            this.outputButton.ToolTipText = "ʂt@Cɏo";
            // 
            // imageList1
            // 
            this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
            this.imageList1.TransparentColor = System.Drawing.Color.White;
            this.imageList1.Images.SetKeyName(0, "");
            this.imageList1.Images.SetKeyName(1, "");
            this.imageList1.Images.SetKeyName(2, "");
            this.imageList1.Images.SetKeyName(3, "new.bmp");
            // 
            // label1
            // 
            this.label1.Location = new System.Drawing.Point(8, 42);
            this.label1.Name = "label1";
            this.label1.Size = new System.Drawing.Size(80, 16);
            this.label1.TabIndex = 12;
            this.label1.Text = "ꏊ";
            this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label2
            // 
            this.label2.Location = new System.Drawing.Point(8, 74);
            this.label2.Name = "label2";
            this.label2.Size = new System.Drawing.Size(80, 16);
            this.label2.TabIndex = 13;
            this.label2.Text = "";
            this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label3
            // 
            this.label3.Location = new System.Drawing.Point(8, 106);
            this.label3.Name = "label3";
            this.label3.Size = new System.Drawing.Size(80, 16);
            this.label3.TabIndex = 14;
            this.label3.Text = "t@C";
            this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // searchPlaceBox
            // 
            this.searchPlaceBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.searchPlaceBox.Location = new System.Drawing.Point(104, 40);
            this.searchPlaceBox.Name = "searchPlaceBox";
            this.searchPlaceBox.Size = new System.Drawing.Size(672, 20);
            this.searchPlaceBox.TabIndex = 1;
            this.searchPlaceBox.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.searchPlaceBox_KeyPress);
            // 
            // searchStringBox
            // 
            this.searchStringBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.searchStringBox.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.Append;
            this.searchStringBox.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;
            this.searchStringBox.Location = new System.Drawing.Point(104, 72);
            this.searchStringBox.Name = "searchStringBox";
            this.searchStringBox.Size = new System.Drawing.Size(672, 20);
            this.searchStringBox.TabIndex = 3;
            this.searchStringBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.searchStringBox_KeyDown);
            // 
            // fileNameBox
            // 
            this.fileNameBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.fileNameBox.AutoCompleteMode = System.Windows.Forms.AutoCompleteMode.Append;
            this.fileNameBox.AutoCompleteSource = System.Windows.Forms.AutoCompleteSource.ListItems;
            this.fileNameBox.Location = new System.Drawing.Point(104, 104);
            this.fileNameBox.Name = "fileNameBox";
            this.fileNameBox.Size = new System.Drawing.Size(672, 20);
            this.fileNameBox.TabIndex = 4;
            this.fileNameBox.KeyDown += new System.Windows.Forms.KeyEventHandler(this.fileNameBox_KeyDown);
            // 
            // subFolderCheckBox
            // 
            this.subFolderCheckBox.Checked = true;
            this.subFolderCheckBox.CheckState = System.Windows.Forms.CheckState.Checked;
            this.subFolderCheckBox.Location = new System.Drawing.Point(25, 179);
            this.subFolderCheckBox.Name = "subFolderCheckBox";
            this.subFolderCheckBox.Size = new System.Drawing.Size(124, 24);
            this.subFolderCheckBox.TabIndex = 5;
            this.subFolderCheckBox.Text = "TutH_܂߂";
            // 
            // caseSensitiveCheckBox
            // 
            this.caseSensitiveCheckBox.Location = new System.Drawing.Point(173, 179);
            this.caseSensitiveCheckBox.Name = "caseSensitiveCheckBox";
            this.caseSensitiveCheckBox.Size = new System.Drawing.Size(156, 24);
            this.caseSensitiveCheckBox.TabIndex = 6;
            this.caseSensitiveCheckBox.Text = "啶ʂ";
            // 
            // regExCheckBox
            // 
            this.regExCheckBox.Location = new System.Drawing.Point(353, 179);
            this.regExCheckBox.Name = "regExCheckBox";
            this.regExCheckBox.Size = new System.Drawing.Size(104, 24);
            this.regExCheckBox.TabIndex = 7;
            this.regExCheckBox.Text = "K\";
            // 
            // folderBrowseButton
            // 
            this.folderBrowseButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.folderBrowseButton.Location = new System.Drawing.Point(788, 39);
            this.folderBrowseButton.Name = "folderBrowseButton";
            this.folderBrowseButton.Size = new System.Drawing.Size(52, 23);
            this.folderBrowseButton.TabIndex = 2;
            this.folderBrowseButton.Text = "Q...";
            this.folderBrowseButton.Click += new System.EventHandler(this.folderBrowseButton_Click);
            // 
            // groupBox1
            // 
            this.groupBox1.Controls.Add(this.trailingLinesToPrintBox);
            this.groupBox1.Controls.Add(this.leadingLinesToPrintBox);
            this.groupBox1.Controls.Add(this.label8);
            this.groupBox1.Controls.Add(this.label7);
            this.groupBox1.Controls.Add(this.label6);
            this.groupBox1.Controls.Add(this.label5);
            this.groupBox1.Location = new System.Drawing.Point(25, 219);
            this.groupBox1.Name = "groupBox1";
            this.groupBox1.Size = new System.Drawing.Size(212, 52);
            this.groupBox1.TabIndex = 8;
            this.groupBox1.TabStop = false;
            this.groupBox1.Text = "}b`s̑O̕\s";
            // 
            // trailingLinesToPrintBox
            // 
            this.trailingLinesToPrintBox.Location = new System.Drawing.Point(140, 21);
            this.trailingLinesToPrintBox.Name = "trailingLinesToPrintBox";
            this.trailingLinesToPrintBox.Size = new System.Drawing.Size(40, 19);
            this.trailingLinesToPrintBox.TabIndex = 1;
            this.trailingLinesToPrintBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.trailingLinesToPrintBox.Value = new decimal(new int[] {
            5,
            0,
            0,
            0});
            // 
            // leadingLinesToPrintBox
            // 
            this.leadingLinesToPrintBox.Location = new System.Drawing.Point(32, 21);
            this.leadingLinesToPrintBox.Name = "leadingLinesToPrintBox";
            this.leadingLinesToPrintBox.Size = new System.Drawing.Size(40, 19);
            this.leadingLinesToPrintBox.TabIndex = 0;
            this.leadingLinesToPrintBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.leadingLinesToPrintBox.Value = new decimal(new int[] {
            5,
            0,
            0,
            0});
            // 
            // label8
            // 
            this.label8.Location = new System.Drawing.Point(184, 20);
            this.label8.Name = "label8";
            this.label8.Size = new System.Drawing.Size(20, 20);
            this.label8.TabIndex = 5;
            this.label8.Text = "s";
            this.label8.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label7
            // 
            this.label7.Location = new System.Drawing.Point(116, 20);
            this.label7.Name = "label7";
            this.label7.Size = new System.Drawing.Size(20, 20);
            this.label7.TabIndex = 4;
            this.label7.Text = "";
            this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label6
            // 
            this.label6.Location = new System.Drawing.Point(76, 20);
            this.label6.Name = "label6";
            this.label6.Size = new System.Drawing.Size(24, 20);
            this.label6.TabIndex = 3;
            this.label6.Text = "s";
            this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label5
            // 
            this.label5.Location = new System.Drawing.Point(8, 22);
            this.label5.Name = "label5";
            this.label5.Size = new System.Drawing.Size(20, 16);
            this.label5.TabIndex = 2;
            this.label5.Text = "O";
            this.label5.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label4
            // 
            this.label4.Location = new System.Drawing.Point(248, 84);
            this.label4.Name = "label4";
            this.label4.Size = new System.Drawing.Size(164, 23);
            this.label4.TabIndex = 0;
            this.label4.Text = "}b`subN̋؂s";
            this.label4.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // label9
            // 
            this.label9.Location = new System.Drawing.Point(460, 84);
            this.label9.Name = "label9";
            this.label9.Size = new System.Drawing.Size(20, 23);
            this.label9.TabIndex = 2;
            this.label9.Text = "s";
            this.label9.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
            // 
            // groupBox2
            // 
            this.groupBox2.Controls.Add(this.blankLineBetweenBlocksBox);
            this.groupBox2.Controls.Add(this.label4);
            this.groupBox2.Controls.Add(this.label9);
            this.groupBox2.Location = new System.Drawing.Point(11, 157);
            this.groupBox2.Name = "groupBox2";
            this.groupBox2.Size = new System.Drawing.Size(492, 133);
            this.groupBox2.TabIndex = 9;
            this.groupBox2.TabStop = false;
            this.groupBox2.Text = "IvV";
            // 
            // blankLineBetweenBlocksBox
            // 
            this.blankLineBetweenBlocksBox.Location = new System.Drawing.Point(416, 86);
            this.blankLineBetweenBlocksBox.Name = "blankLineBetweenBlocksBox";
            this.blankLineBetweenBlocksBox.Size = new System.Drawing.Size(40, 19);
            this.blankLineBetweenBlocksBox.TabIndex = 1;
            this.blankLineBetweenBlocksBox.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
            this.blankLineBetweenBlocksBox.Value = new decimal(new int[] {
            1,
            0,
            0,
            0});
            // 
            // statusBar
            // 
            this.statusBar.Location = new System.Drawing.Point(0, 624);
            this.statusBar.Name = "statusBar";
            this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
            this.statusBarPanel1,
            this.statusBarPanel2});
            this.statusBar.ShowPanels = true;
            this.statusBar.Size = new System.Drawing.Size(852, 22);
            this.statusBar.TabIndex = 19;
            this.statusBar.DrawItem += new System.Windows.Forms.StatusBarDrawItemEventHandler(this.statusBar_DrawItem);
            // 
            // statusBarPanel1
            // 
            this.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
            this.statusBarPanel1.Name = "statusBarPanel1";
            this.statusBarPanel1.Width = 735;
            // 
            // statusBarPanel2
            // 
            this.statusBarPanel2.Alignment = System.Windows.Forms.HorizontalAlignment.Right;
            this.statusBarPanel2.Name = "statusBarPanel2";
            this.statusBarPanel2.Style = System.Windows.Forms.StatusBarPanelStyle.OwnerDraw;
            // 
            // progressBar1
            // 
            this.progressBar1.Location = new System.Drawing.Point(580, 180);
            this.progressBar1.Name = "progressBar1";
            this.progressBar1.Size = new System.Drawing.Size(100, 23);
            this.progressBar1.TabIndex = 11;
            // 
            // dataGridView1
            // 
            this.dataGridView1.AllowUserToAddRows = false;
            this.dataGridView1.AllowUserToDeleteRows = false;
            this.dataGridView1.AllowUserToResizeRows = false;
            this.dataGridView1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.dataGridView1.ClipboardCopyMode = System.Windows.Forms.DataGridViewClipboardCopyMode.EnableWithoutHeaderText;
            this.dataGridView1.ColumnHeadersHeightSizeMode = System.Windows.Forms.DataGridViewColumnHeadersHeightSizeMode.AutoSize;
            this.dataGridView1.Columns.AddRange(new System.Windows.Forms.DataGridViewColumn[] {
            this.fileName,
            this.place,
            this.lineNumber,
            this.contents});
            this.dataGridView1.ContextMenuStrip = this.contextMenuStrip1;
            this.dataGridView1.Location = new System.Drawing.Point(10, 321);
            this.dataGridView1.MultiSelect = false;
            this.dataGridView1.Name = "dataGridView1";
            this.dataGridView1.ReadOnly = true;
            this.dataGridView1.RowHeadersVisible = false;
            this.dataGridView1.RowTemplate.Height = 21;
            this.dataGridView1.SelectionMode = System.Windows.Forms.DataGridViewSelectionMode.CellSelect;
            this.dataGridView1.Size = new System.Drawing.Size(830, 285);
            this.dataGridView1.TabIndex = 20;
            this.dataGridView1.CellDoubleClick += new System.Windows.Forms.DataGridViewCellEventHandler(this.dataGridView1_CellDoubleClick);
            this.dataGridView1.CellFormatting += new System.Windows.Forms.DataGridViewCellFormattingEventHandler(this.dataGridView1_CellFormatting);
            // 
            // fileName
            // 
            this.fileName.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.None;
            this.fileName.DataPropertyName = "t@C";
            this.fileName.HeaderText = "t@C";
            this.fileName.Name = "fileName";
            this.fileName.ReadOnly = true;
            this.fileName.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.NotSortable;
            this.fileName.Width = 150;
            // 
            // place
            // 
            this.place.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.None;
            this.place.DataPropertyName = "ꏊ";
            this.place.HeaderText = "ꏊ";
            this.place.Name = "place";
            this.place.ReadOnly = true;
            this.place.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.NotSortable;
            this.place.Width = 200;
            // 
            // lineNumber
            // 
            this.lineNumber.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.None;
            this.lineNumber.DataPropertyName = "sԍ";
            this.lineNumber.HeaderText = "sԍ";
            this.lineNumber.Name = "lineNumber";
            this.lineNumber.ReadOnly = true;
            this.lineNumber.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.NotSortable;
            this.lineNumber.Width = 75;
            // 
            // contents
            // 
            this.contents.AutoSizeMode = System.Windows.Forms.DataGridViewAutoSizeColumnMode.None;
            this.contents.DataPropertyName = "e";
            this.contents.HeaderText = "e";
            this.contents.Name = "contents";
            this.contents.ReadOnly = true;
            this.contents.SortMode = System.Windows.Forms.DataGridViewColumnSortMode.NotSortable;
            this.contents.Width = 400;
            // 
            // contextMenuStrip1
            // 
            this.contextMenuStrip1.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            this.copyContextMenuItem});
            this.contextMenuStrip1.Name = "contextMenuStrip1";
            this.contextMenuStrip1.Size = new System.Drawing.Size(131, 26);
            // 
            // copyContextMenuItem
            // 
            this.copyContextMenuItem.Name = "copyContextMenuItem";
            this.copyContextMenuItem.Size = new System.Drawing.Size(130, 22);
            this.copyContextMenuItem.Text = "Rs[(&C)";
            this.copyContextMenuItem.Click += new System.EventHandler(this.copyContextMenuItem_Click);
            // 
            // label10
            // 
            this.label10.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)));
            this.label10.AutoSize = true;
            this.label10.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label10.Location = new System.Drawing.Point(12, 306);
            this.label10.Name = "label10";
            this.label10.Size = new System.Drawing.Size(57, 12);
            this.label10.TabIndex = 21;
            this.label10.Text = "";
            // 
            // label11
            // 
            this.label11.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.label11.AutoSize = true;
            this.label11.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label11.Location = new System.Drawing.Point(672, 306);
            this.label11.Name = "label11";
            this.label11.Size = new System.Drawing.Size(57, 12);
            this.label11.TabIndex = 22;
            this.label11.Text = "o͍s";
            // 
            // outputLineCount
            // 
            this.outputLineCount.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.outputLineCount.AutoSize = true;
            this.outputLineCount.Location = new System.Drawing.Point(735, 306);
            this.outputLineCount.MinimumSize = new System.Drawing.Size(78, 0);
            this.outputLineCount.Name = "outputLineCount";
            this.outputLineCount.Size = new System.Drawing.Size(78, 12);
            this.outputLineCount.TabIndex = 23;
            this.outputLineCount.Text = "0";
            this.outputLineCount.TextAlign = System.Drawing.ContentAlignment.TopRight;
            // 
            // label13
            // 
            this.label13.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.label13.AutoSize = true;
            this.label13.Font = new System.Drawing.Font("MS UI Gothic", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(128)));
            this.label13.Location = new System.Drawing.Point(816, 306);
            this.label13.Name = "label13";
            this.label13.Size = new System.Drawing.Size(18, 12);
            this.label13.TabIndex = 24;
            this.label13.Text = "s";
            // 
            // label12
            // 
            this.label12.AutoSize = true;
            this.label12.Location = new System.Drawing.Point(101, 127);
            this.label12.Name = "label12";
            this.label12.Size = new System.Drawing.Size(385, 12);
            this.label12.TabIndex = 25;
            this.label12.Text = "t@Cɂ̓ChJ[h(*,?)gp@ꍇ̓Z~R(;)ŋ؂";
            // 
            // MainWindow
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
            this.ClientSize = new System.Drawing.Size(852, 646);
            this.Controls.Add(this.dataGridView1);
            this.Controls.Add(this.progressBar1);
            this.Controls.Add(this.label13);
            this.Controls.Add(this.statusBar);
            this.Controls.Add(this.label12);
            this.Controls.Add(this.groupBox1);
            this.Controls.Add(this.label11);
            this.Controls.Add(this.folderBrowseButton);
            this.Controls.Add(this.caseSensitiveCheckBox);
            this.Controls.Add(this.outputLineCount);
            this.Controls.Add(this.regExCheckBox);
            this.Controls.Add(this.fileNameBox);
            this.Controls.Add(this.subFolderCheckBox);
            this.Controls.Add(this.searchStringBox);
            this.Controls.Add(this.searchPlaceBox);
            this.Controls.Add(this.label3);
            this.Controls.Add(this.label10);
            this.Controls.Add(this.label2);
            this.Controls.Add(this.label1);
            this.Controls.Add(this.toolBar1);
            this.Controls.Add(this.groupBox2);
            this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
            this.Menu = this.mainMenu1;
            this.Name = "MainWindow";
            this.Text = "CsCgrep";
            this.Load += new System.EventHandler(this.MainWindow_Load);
            this.Shown += new System.EventHandler(this.MainWindow_Shown);
            this.Activated += new System.EventHandler(this.MainWindow_Activated);
            this.Closing += new System.ComponentModel.CancelEventHandler(this.MainWindow_Closing);
            this.groupBox1.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.trailingLinesToPrintBox)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.leadingLinesToPrintBox)).EndInit();
            this.groupBox2.ResumeLayout(false);
            ((System.ComponentModel.ISupportInitialize)(this.blankLineBetweenBlocksBox)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.statusBarPanel2)).EndInit();
            ((System.ComponentModel.ISupportInitialize)(this.dataGridView1)).EndInit();
            this.contextMenuStrip1.ResumeLayout(false);
            this.ResumeLayout(false);
            this.PerformLayout();

		}
		#endregion

		/// <summary>
		/// AvP[ṼC Gg |CgłB
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainWindow());
		}

		/// <summary>
		/// CsCgrepEBhẼ[h̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void MainWindow_Load(object sender, System.EventArgs e)
		{
			if (applicationSettings.LoadAppSettings())
			{
                // ŌɎQƂĂtH_ݒ
				if (applicationSettings.LastBrowseFolder != null)
				{
					searchPlaceBox.Text = applicationSettings.LastBrowseFolder;
				}

				// tH_̓͗ݒ
				foreach(string folder in applicationSettings.FolderHistories)
				{
					searchPlaceBox.Items.Add(folder);
				}

				// ̓͗ݒ
				foreach(string keyword in applicationSettings.KeywordHistories)
				{
					searchStringBox.Items.Add(keyword);
				}

				// t@C̓͗ݒ
				foreach(string fileName in applicationSettings.FileNameHistories)
				{
					fileNameBox.Items.Add(fileName);
				}
                
                // Ōɓ͂ꂽt@Cݒ
                if (applicationSettings.FileNameHistories.Count > 0)
                {
                    fileNameBox.Text = applicationSettings.FileNameHistories[0].ToString();
                }

				int winWidth = applicationSettings.WindowWidth;

				if (winWidth > 0)
				{
					Width = winWidth;
				}

				int winHeight = applicationSettings.WindowHeight;

				if (winHeight > 0)
				{
					Height = winHeight;
				}

				int winX = applicationSettings.WindowX;
				int winY = applicationSettings.WindowY;

				if (winX > 0 && winY > 0)
				{
					Location = new Point(winX, winY);
				}

				// `FbN{bNX̏Ԃݒ
				subFolderCheckBox.Checked = applicationSettings.SearchSubFolder;
				caseSensitiveCheckBox.Checked = applicationSettings.CaseSensitive;
				regExCheckBox.Checked = applicationSettings.UseRegularExpressions;

				// s̐ݒ
				leadingLinesToPrintBox.Value = applicationSettings.LeadingLinesToPrint;
				trailingLinesToPrintBox.Value = applicationSettings.TrailingLinesToPrint;
				blankLineBetweenBlocksBox.Value = applicationSettings.BlankLinesBetweenBlocks;

				// ő剻Ԃ̐ݒ
				if (applicationSettings.IsMaximizedOnTerminate)
				{
					WindowState = FormWindowState.Maximized;
				}

                // t@C͎̃GR[fBO烁j[̑Iݒ
                switch (applicationSettings.InputEncoding)
                {
                    case Constants.SHIFT_JIS:
                        inputSjisMenuItem.Checked = true;
                        inputUtf8MenuItem.Checked = false;
                        inputEucMenuItem.Checked = false;
                        break;
                    case Constants.UTF8:
                        inputSjisMenuItem.Checked = false;
                        inputUtf8MenuItem.Checked = true;
                        inputEucMenuItem.Checked = false;
                        break;
                    case Constants.EUC:
                        inputSjisMenuItem.Checked = false;
                        inputUtf8MenuItem.Checked = false;
                        inputEucMenuItem.Checked = true;
                        break;
                    default:
                        inputSjisMenuItem.Checked = true;
                        inputUtf8MenuItem.Checked = false;
                        inputEucMenuItem.Checked = false;
                        break;
                }

                // t@Cõ͎GR[fBO烁j[̑Iݒ
                switch (applicationSettings.OutputEncoding)
                {
                    case Constants.SHIFT_JIS:
                        outputSjisMenuItem.Checked = true;
                        outputUtf8MenuItem.Checked = false;
                        outputEucMenuItem.Checked = false;
                        break;
                    case Constants.UTF8:
                        outputSjisMenuItem.Checked = false;
                        outputUtf8MenuItem.Checked = true;
                        outputEucMenuItem.Checked = false;
                        break;
                    case Constants.EUC:
                        outputSjisMenuItem.Checked = false;
                        outputUtf8MenuItem.Checked = false;
                        outputEucMenuItem.Checked = true;
                        break;
                    default:
                        outputSjisMenuItem.Checked = true;
                        outputUtf8MenuItem.Checked = false;
                        outputEucMenuItem.Checked = false;
                        break;
                }

			}
		}

        /// <summary>
        /// tH[ŏɕ\ꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void MainWindow_Shown(object sender, EventArgs e)
        {
            searchPlaceBox.SelectionLength = 0;
            fileNameBox.SelectionLength = 0;
        }

        /// <summary>
        /// tH[ANeBuꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void MainWindow_Activated(object sender, EventArgs e)
        {
            searchPlaceBox.SelectionLength = 0;
            fileNameBox.SelectionLength = 0;
        }

		/// <summary>
		/// CsCgrepEBhẼN[Y̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void MainWindow_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			StopSearchThread();
			CloseWindow();
		}

		/// <summary>
		/// sXbh~܂B
		/// </summary>
		private void StopSearchThread()
		{
			if (searchThread != null && searchThread.IsAlive)
			{
				try 
				{
					searchThread.Abort();
					searchThread = null;
				}
				catch (ThreadAbortException ae)
				{
					Debug.WriteLine("ThreadAbortException occured in MainWindow.StopSearchThread()");
					Debug.WriteLine(ae.Message);
					Debug.WriteLine(ae.StackTrace);

					Log log = Log.GetInstance();
					log.Error("ThreadAbortException occured in MainWindow.StopSearchThread()");
					log.Error(ae.Message);
					log.Error(ae.StackTrace);
				}
			}
		}

		/// <summary>
		/// EBhEN[YłB
		/// </summary>
		private void CloseWindow()
		{
			// EBhEʏ\̏ꍇ̓TCYƈʒuۑ
			if (WindowState == FormWindowState.Normal)
			{
				applicationSettings.WindowHeight = Height;
				applicationSettings.WindowWidth = Width;
				applicationSettings.WindowX = Location.X;
				applicationSettings.WindowY = Location.Y;
			}

			// EBhEő剻Ԃ̏ꍇ͍ő剻ԃtOZbg
			if (WindowState == FormWindowState.Maximized)
			{
				applicationSettings.IsMaximizedOnTerminate = true;
			}
			else
			{
				applicationSettings.IsMaximizedOnTerminate = false;
			}

			applicationSettings.LastBrowseFolder = searchPlaceBox.Text;

			// `FbN{bNX̐ݒl̕ۑ
			applicationSettings.SearchSubFolder = subFolderCheckBox.Checked;
			applicationSettings.CaseSensitive = caseSensitiveCheckBox.Checked;
			applicationSettings.UseRegularExpressions = regExCheckBox.Checked;

			// }b`s̑O̕\sۑ
			applicationSettings.LeadingLinesToPrint = (int) leadingLinesToPrintBox.Value;
			applicationSettings.TrailingLinesToPrint = (int) trailingLinesToPrintBox.Value;

			// }b`subN̋؂sۑ
			applicationSettings.BlankLinesBetweenBlocks = (int) blankLineBetweenBlocksBox.Value;

			applicationSettings.SaveAppSettings();
		}

		/// <summary>
		/// grepsXbhN܂B
		/// </summary>
		private void Grep()
		{
			ThreadStart worker = new ThreadStart(ExecuteGrep);
			searchThread = new Thread(worker);
			searchThread.Start();
		}

		/// <summary>
		/// greps܂B
		/// </summary>
		private void ExecuteGrep()
		{
            // ʈꗗ̏o͍s
            Invoke(new SetOutputLineCountDelegate(SetOuputLineCount), new object[] { 0 });

            // Ώۂ̃t@CXg擾
            ArrayList searchFiles = (ArrayList)GetSearchFiles();

			// vOXo[̍őAŏݒ
			Invoke(new SetMinimumAndMaximumOfProgressBarDelegate(SetMinimumAndMaximumOfProgressBar),
				new object[]{0, searchFiles.Count});

			// vOXo[̒lZbg
			Invoke(new SetCurrentValueOfProgressBarDelegate(SetCurrentValueOfProgressBar),
				new object[]{0});

            // ʈꗗ̍XV~
            Invoke(new StopResultUpdateDelegate(StopResultUpdate));

			// grepsIuWFNg̍쐬
			Cgrep cgrep = new Cgrep();

			// p[^̐ݒ
			Invoke(new SetSearchParameterDelegate(SetSearchParameter),
				new object[]{cgrep});

			// ʂ̏
			searchResults.Clear();

            // ̉
            GC.Collect();

			foreach (string file in searchFiles)
			{
				SetStatusBarText("...  " + file);
				Debug.WriteLine("...  " + file);

				// vOXo[̒lCNg
				Invoke(new IncrementProgressBarDelegate(IncrementProgressBar),
					new object[]{1});

				int startRow = searchResults.Count;

                string searchString = (string) Invoke(new GetSearchStringDelegate(GetSearchStringText));

                ArrayList result = cgrep.Grep(file, searchString);

				FileInfo fi = new FileInfo(file);
				Debug.WriteLine("ǉJn(" + fi.Name + ")");
				Debug.WriteLine("VKǉR[hF" + result.Count);

				searchResults.AddRange(result);

				foreach (SearchResult r in result)
				{
					Invoke(new AddSearchResultDelegate(AddSearchResult),
						new object[]{r});
				}

				Debug.WriteLine("ǉI");
				Debug.WriteLine("ʑs = " + searchResults.Count);
			}

			SetStatusBarText("I");

            // f[^ObhɃf[^e[uA
            Invoke(new BindDataTableDelegate(BindDataTable),
                new object[] { resultTable });

            if (searchResults.Count > 0)
            {
                // f[^Obh̓e̕𒲐
                Invoke(new AutoSizeColumnWidthDelegate(AutoSizeColumnWidth));

                // }b`s̐FύX
                Invoke(new ChangeMatchingLinesDelegate(ChangeMatchingLines));

                // ʈꗗ̃Z̑INA
                Invoke(new ClearCellSelectionDelegate(ClearCellSelection));

                // ʈꗗ̃Z̃\[gsɐݒ
                Invoke(new SetNotSortableDelegate(SetNotSortable));

                // ʈꗗ̏o͍sݒ
                Invoke(new SetOutputLineCountDelegate(SetOuputLineCount), new object[] { searchResults.Count });
            }

            // ʈꗗ̍XVĊJ
            Invoke(new StartResultUpdateDelegate(StartResultUpdate));

			// s{^L
			Invoke(new SetButtonStateDelegate(SetButtonStateOnFinish));

			// vOXo[̒lZbg
			Invoke(new SetCurrentValueOfProgressBarDelegate(SetCurrentValueOfProgressBar),
				new object[]{0});
		}

        /// <summary>
        /// 擾܂B
        /// </summary>
        /// <returns></returns>
        private string GetSearchStringText()
        {
            return searchStringBox.Text;
        }

        /// <summary>
        /// ꏊԂ܂B
        /// </summary>
        /// <returns>ꏊ</returns>
        private string GetSearchPlaceText()
        {
            return searchPlaceBox.Text;
        }

        /// <summary>
        /// Ώۃt@CԂ܂B
        /// </summary>
        /// <returns>Ώۃt@C</returns>
        private string GetSearchFileName()
        {
            return fileNameBox.Text;
        }

        /// <summary>
        /// TutH_邩ǂ
        /// </summary>
        /// <returns>TutH_ꍇtrueAłȂꍇfalse</returns>
        private bool IsSearchSubFolder()
        {
            return subFolderCheckBox.Checked;
        }

		/// <summary>
		/// Ώۂ̃t@CXg擾܂B
		/// </summary>
		/// <returns>Ώۂ̃t@CXg</returns>
		private ArrayList GetSearchFiles()
		{
            string fileNames = (string) Invoke(new GetSearchFileNameDelegate(GetSearchFileName));
            string[] patterns = fileNames.Split(';');

			// Ώۂ̃t@CXg
			ArrayList searchFiles = new ArrayList();

			// t@CXg擾NX
			FileRetriever retriever = new FileRetriever(this);

            // ꏊ
            string searchPlace = (string)Invoke(new GetSearchPlaceDelegate(GetSearchPlaceText));

            // TutH_邩ǂ
            bool searchSubFolder = (bool)Invoke(new IsSearchSubFolderDelegate(IsSearchSubFolder));

			foreach (string filePattern in patterns)
			{
				// TutH_ꍇ
                if (searchSubFolder)
				{
					retriever.GetAllFilesRecursive(
                        searchPlace, filePattern.Trim(), ref searchFiles);
				}
				else
				{
					retriever.GetAllFilesInDirectory(
                        searchPlace, filePattern.Trim(), ref searchFiles);
				}
			}

			return searchFiles;
		}

		/// <summary>
		/// p[^ݒ肵܂B
		/// </summary>
		/// <param name="cgrep">IuWFNg</param>
		private void SetSearchParameter(Cgrep cgrep)
		{
			cgrep.IgnoreCase = ! caseSensitiveCheckBox.Checked;
			cgrep.LeadingLinesToPrint = (int) leadingLinesToPrintBox.Value;
			cgrep.TrailingLinesToPrint = (int) trailingLinesToPrintBox.Value;
			cgrep.BlankLinesBetweenBlocks = (int) blankLineBetweenBlocksBox.Value;
			cgrep.IsRegularExpression = regExCheckBox.Checked;
            cgrep.FileEncoding = applicationSettings.InputEncoding;
		}

		/// <summary>
		/// Xe[^Xo[̃eLXgݒ肵܂B
		/// </summary>
		/// <param name="s">eLXg</param>
		public void SetStatusBarText(string s)
		{
			Invoke(new SetStatusBarTextDelegate(DoSetStatusBarText),
				new object[]{s});
		}

		/// <summary>
		/// Xe[^Xo[̃eLXgݒ肵܂B
		/// </summary>
		/// <param name="s">eLXg</param>
		private void DoSetStatusBarText(string s)
		{
			statusBarPanel1.Text = s;
		}

		/// <summary>
		/// vOXo[̍őAŏlݒ肵܂B
		/// </summary>
		/// <param name="min">ŏl</param>
		/// <param name="max">ől</param>
		private void SetMinimumAndMaximumOfProgressBar(int min, int max)
		{
			progressBar1.Minimum = min;
			progressBar1.Maximum = max;
		}

		/// <summary>
		/// vOXo[̌ݒlݒ肵܂B
		/// </summary>
		/// <param name="value">ݒ肷l</param>
		private void SetCurrentValueOfProgressBar(int value)
		{
			progressBar1.Value = value;
		}

		/// <summary>
		/// vOXo[̌ݒl𑝂₵܂B
		/// </summary>
		/// <param name="value">₷l</param>
		private void IncrementProgressBar(int value)
		{
			progressBar1.Increment(value);
		}

		/// <summary>
		/// ʂ̈sꗗɒǉ܂B
		/// </summary>
		/// <param name="r">ʂ̈s</param>
		private void AddSearchResult(SearchResult r)
		{
            string rowNumber = "";

            if (r.RowNumber != 0)
            {
                rowNumber = r.RowNumber.ToString();
            }

            resultTable.Rows.Add(new object[] { r.FileName, r.Place, rowNumber, r.Contents });

            //int rowIndex = dataGridView1.Rows.Add();

            //// t@C
            //dataGridView1[0, rowIndex].Value = r.FileName;

            //// ꏊ
            //dataGridView1[1, rowIndex].Value = r.Place;

            //// sԍ
            //if (r.RowNumber > 0)
            //{
            //    dataGridView1[2, rowIndex].Value = r.RowNumber;
            //}
            //else
            //{
            //    dataGridView1[2, rowIndex].Value = "";
            //}

            //// e
            //dataGridView1[3, rowIndex].Value = r.Contents;

			Application.DoEvents();
		}

        /// <summary>
        /// ʈꗗ̍XVꎞ~܂B
        /// </summary>
        private void StopResultUpdate()
        {
            dataGridView1.SuspendLayout();
        }

        /// <summary>
        /// ʈꗗ̍XVĊJ܂B
        /// </summary>
        private void StartResultUpdate()
        {
            dataGridView1.ResumeLayout();
        }

		/// <summary>
		/// Jn̊e{^̏Ԃݒ肵܂B
		/// </summary>
		private void SetButtonStateOnStart()
		{
            searchButton.Enabled = false;
            cancelButton.Enabled = true;
            outputButton.Enabled = false;

		}

        /// <summary>
        /// I̊e{^̏Ԃݒ肵܂B
        /// </summary>
        private void SetButtonStateOnFinish()
        {
            searchButton.Enabled = true;
            cancelButton.Enabled = false;
            outputButton.Enabled = true;
        }

		/// <summary>
		/// ̓`FbNAsĂяo܂B
		/// </summary>
		private void CallGrep() 
		{
			if (InputDataIsValid())
			{
                SetButtonStateOnStart();
				SaveInputHistory();
                BindDataTable(null);
                resultTable = CreateDataTable();
                Grep();
			}
		}

		/// <summary>
		/// c[o[̃{^NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender"></param>
		/// <param name="e"></param>
		private void toolBar1_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			if (e.Button == searchButton)
			{
				CallGrep();
			}
			else if (e.Button == cancelButton)
			{
				StopSearchThread();
                searchResults.Clear();
				SetStatusBarText("𒆒f܂");
                SetButtonStateOnFinish();
				SetCurrentValueOfProgressBar(0);
			}
            else if (e.Button == outputButton)
            {
                ShowOutputDialog();
            }
		}

		/// <summary>
		/// f[^ObhɃf[^e[uA܂B
		/// </summary>
		/// <param name="dt">f[^e[u</param>
		private void BindDataTable(DataTable dt)
		{
            if (dt != null && dt.Rows.Count > 0)
            {
                dataGridView1.DataSource = dt;
            }
            else
            {
                dataGridView1.DataSource = null;
            }
        }

		/// <summary>
		/// ɓ͂ꂽ`FbN܂B
		/// </summary>
		/// <returns>`FbN</returns>
		private bool InputDataIsValid()
		{
			if (searchPlaceBox.Text.Length == 0)
			{
				MessageUtil.ShowAlert("ꏊ͂ĂB");
				return false;
			}

			if (searchStringBox.Text.Length == 0)
			{
				MessageUtil.ShowAlert("͂ĂB");
				return false;
			}

			if (fileNameBox.Text.Length == 0)
			{
				MessageUtil.ShowAlert("Ώۃt@C͂ĂB");
				return false;
			}

			DirectoryInfo di = new DirectoryInfo(searchPlaceBox.Text);

			if (! di.Exists)
			{
				MessageUtil.ShowAlert("w肳ꂽꏊ݂͑܂B");
				return false;
			}

			if (regExCheckBox.Checked)
			{
				try
				{
					Regex ex = new  Regex(searchStringBox.Text);
				}
				catch (Exception ex)
				{
					Debug.WriteLine(ex.Message);
					Debug.WriteLine(ex.StackTrace);

					MessageUtil.ShowAlert("K\słB");
					return false;
				}
			}

			return true;
		}

		/// <summary>
		/// ɓ͂ꂽ𗚗ɕۑ܂B
		/// </summary>
		private void SaveInputHistory()
		{
			// ͂ꂽtH_܂ɂȂꍇ
			if(! searchPlaceBox.Items.Contains(searchPlaceBox.Text))
			{
				// ͂ꂽtH_𗚗ɕۑ
				applicationSettings.AddFolderHistory(searchPlaceBox.Text);

				searchPlaceBox.Items.Insert(0, searchPlaceBox.Text);

				// ێ̍ő𒴂ꍇ
				if(searchPlaceBox.Items.Count > ApplicationSettings.FOLDER_HISTORY_MAX)
				{
					// Ō̗vf폜
					searchPlaceBox.Items.RemoveAt(
						searchPlaceBox.Items.Count - 1);
				}
			}
			else // łɗɂꍇ
			{
				// ͂ꂽtH_𗚗ɕۑ
				applicationSettings.AddFolderHistory(searchPlaceBox.Text);

				// ͂ꂽeLXgꎞۑ
				string tempText = searchPlaceBox.Text;

				// ݂̗̒̃CfbNX擾
				int index = searchPlaceBox.Items.IndexOf(searchPlaceBox.Text);
				
				// ݂̈ʒũeLXg폜
				searchPlaceBox.Items.RemoveAt(index);

				// ̐擪ɒǉ
				searchPlaceBox.Items.Insert(0, tempText);

				searchPlaceBox.Text = tempText;
			}

			// ͂ꂽꂪ܂ɂȂꍇ
			if(! searchStringBox.Items.Contains(searchStringBox.Text))
			{
				// ͂ꂽ𗚗ɕۑ
				applicationSettings.AddKeywordHistory(searchStringBox.Text);

				searchStringBox.Items.Insert(0, searchStringBox.Text);

				// ێ̍ő𒴂ꍇ
				if(searchStringBox.Items.Count > ApplicationSettings.KEYWORD_HISTORY_MAX)
				{
					// Ō̗vf폜
					searchStringBox.Items.RemoveAt(
						searchStringBox.Items.Count - 1);
				}
			}
			else // łɗɂꍇ
			{
				// ͂ꂽ𗚗ɕۑ
				applicationSettings.AddKeywordHistory(searchStringBox.Text);

				// ͂ꂽeLXgꎞۑ
				string tempText = searchStringBox.Text;

				// ݂̗̒̃CfbNX擾
				int index = searchStringBox.Items.IndexOf(searchStringBox.Text);
				
				// ݂̈ʒũeLXg폜
				searchStringBox.Items.RemoveAt(index);

				// ̐擪ɒǉ
				searchStringBox.Items.Insert(0, tempText);

				searchStringBox.Text = tempText;
			}

			// ͂ꂽt@C܂ɂȂꍇ
			if(! fileNameBox.Items.Contains(fileNameBox.Text))
			{
				// ͂ꂽt@C𗚗ɕۑ
				applicationSettings.AddFileNameHistory(fileNameBox.Text);

				fileNameBox.Items.Insert(0, fileNameBox.Text);

				// ێ̍ő𒴂ꍇ
				if(fileNameBox.Items.Count > ApplicationSettings.FILENAME_HISTORY_MAX)
				{
					// Ō̗vf폜
					fileNameBox.Items.RemoveAt(
						fileNameBox.Items.Count - 1);
				}
			}
			else // łɗɂꍇ
			{
				// ͂ꂽt@C𗚗ɕۑ
				applicationSettings.AddFileNameHistory(fileNameBox.Text);

				// ͂ꂽeLXgꎞۑ
				string tempText = fileNameBox.Text;

				// ݂̗̒̃CfbNX擾
				int index = fileNameBox.Items.IndexOf(fileNameBox.Text);
				
				// ݂̈ʒũeLXg폜
				fileNameBox.Items.RemoveAt(index);

				// ̐擪ɒǉ
				fileNameBox.Items.Insert(0, tempText);

				fileNameBox.Text = tempText;
			}
		}

        /// <summary>
        /// tH_̓͗NA܂B
        /// </summary>
        public void ClearFolderHistory()
        {
            searchPlaceBox.Items.Clear();
            applicationSettings.ClearFolderHistory();
        }

        /// <summary>
        /// ̓͗NA܂B
        /// </summary>
        public void ClearKeywordHistory()
        {
            searchStringBox.Items.Clear();
            applicationSettings.ClearKeywordHistory();
        }


        /// <summary>
        /// t@C̓͗NA܂B
        /// </summary>
        public void ClearFileNameHistory()
        {
            fileNameBox.Items.Clear();
            applicationSettings.ClearFileNameHistory();
        }



		/// <summary>
		/// f[^Obh̏s܂B
		/// </summary>
		private void InitializeDataGrid()
		{
            // Not Used.
		}

		/// <summary>
		/// ̃f[^e[u쐬܂B
		/// </summary>
		/// <returns></returns>
		private DataTable CreateDataTable()
		{
			DataTable dt = new DataTable("DataTable1");
			dt.Columns.Add("t@C");
			dt.Columns.Add("ꏊ");
			dt.Columns.Add("sԍ");
			dt.Columns.Add("e");

			return dt;
		}

		/// <summary>
		/// DataGrid̓e̕Text̕ɍ킹ĕύX
		/// </summary>
		private void AutoSizeColumnWidth()
		{
            dataGridView1.Columns[0].Width = 150;
            dataGridView1.Columns[1].Width = 200;
            dataGridView1.Columns[2].Width = 75;
            dataGridView1.AutoResizeColumn(3);
        }

        /// <summary>
        /// DataGrid̃J\[gsɐݒ肵܂B
        /// </summary>
        private void SetNotSortable()
        {
            // J̃\[gsɐݒ
            dataGridView1.Columns[0].SortMode = DataGridViewColumnSortMode.NotSortable;
            dataGridView1.Columns[1].SortMode = DataGridViewColumnSortMode.NotSortable;
            dataGridView1.Columns[2].SortMode = DataGridViewColumnSortMode.NotSortable;
            dataGridView1.Columns[3].SortMode = DataGridViewColumnSortMode.NotSortable;
        }

        /// <summary>
        /// }b`s̐FύX܂B
        /// </summary>
        private void ChangeMatchingLines()
        {
            for (int rowIndex = 0; rowIndex < searchResults.Count; rowIndex++)
            {
                SearchResult r = (SearchResult) searchResults[rowIndex];

                if (r.IsMatchLine)
                {
                    for (int i = 0; i < 4; i++)
                    {
                        dataGridView1[i, rowIndex].Style.ForeColor = Color.Red;
                        dataGridView1[i, rowIndex].Style.BackColor = Color.LightGoldenrodYellow;
                    }
                }
            }
        }

        /// <summary>
        /// ʈꗗ̃Z̑INA܂B
        /// </summary>
        private void ClearCellSelection()
        {
            dataGridView1.ClearSelection();
        }

        /// <summary>
        /// ʈꗗ̏o͍sݒ肵܂B
        /// </summary>
        /// <param name="count">o͍s</param>
        private void SetOuputLineCount(int count)
        {
            outputLineCount.Text = count.ToString();
        }

		/// <summary>
		/// DataGrid̗̕Text̕ɍ킹ĕύX(gp)
		/// </summary>
		/// <param name="grid">ΏۂƂDataGrid</param>
		/// <param name="column">̔ԍ</param>
		private void DoAutoSizeColumnWidth(DataGrid grid, int column)
		{
			//DataGridGraphics擾
			Graphics g = Graphics.FromHwnd(grid.Handle);

			//ׂẴZ𒲂ׂāAԍL擾
			StringFormat sf =
				new StringFormat(StringFormat.GenericTypographic);
			DataTable dt = ((DataTable) grid.DataSource);
			int rowsCount = dt.Rows.Count;
			float maxColumnWidth = 0.0f;
			
			for (int i = 0; i < rowsCount; i++)
			{
				string text = grid[i, column].ToString();
				maxColumnWidth = Math.Max(g.MeasureString(
					text, grid.Font, grid.Width, sf).Width, maxColumnWidth);
			}

			//wb_̕l
			DataGridColumnStyle cs =
					grid.TableStyles[dt.TableName].GridColumnStyles[column];

			maxColumnWidth = Math.Max(g.MeasureString(
					cs.HeaderText, grid.Font, grid.Width, sf).Width, maxColumnWidth);
    
			//j
			g.Dispose();

			//̕ύX
			cs.Width = (int) maxColumnWidth + 12;
		}

		/// <summary>
		/// Qƃ{^NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void folderBrowseButton_Click(object sender, System.EventArgs e)
		{
			FolderBrowserDialog dialog = new FolderBrowserDialog();
			dialog.Description = "Ώۂ̃tH_IĂB";

			DialogResult result = dialog.ShowDialog();

			if(result == DialogResult.OK)
			{
				searchPlaceBox.Text = dialog.SelectedPath;
			}
		}

		/// <summary>
		/// Ij[NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void exitMenuItem_Click(object sender, System.EventArgs e)
		{
			Close();
		}

		/// <summary>
		/// o[W񃁃j[NbNꂽƂ̏łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="e">Cxg</param>
		private void versionMenuItem_Click(object sender, System.EventArgs e)
		{
			VersionDialog dialog = new VersionDialog();
			dialog.ShowDialog();
		}

		/// <summary>
		/// Xe[^Xo[̓e`悷鏈łB
		/// </summary>
		/// <param name="sender">Cxg𔭐IuWFNg</param>
		/// <param name="sbdevent">Cxg</param>
		private void statusBar_DrawItem(object sender, System.Windows.Forms.StatusBarDrawItemEventArgs sbdevent)
		{
			if (sbdevent.Panel == statusBarPanel2)
			{
				StatusBar sb = (StatusBar)sender;
				Rectangle rect = sbdevent.Bounds;
				progressBar1.SetBounds(sb.Location.X + rect.X, sb.Location.Y + rect.Y, 
					rect.Width, rect.Height);
			}
		}

        /// <summary>
        /// ꏊ̓{bNXŃL[ꂽƂ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void searchPlaceBox_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)Keys.Enter)
            {
                CallGrep();
                e.Handled = true;
            }
        }

        /// <summary>
        /// ꏊ̓{bNXŃL[ꂽƂ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void searchStringBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                CallGrep();
                e.Handled = true;
            }
        }

        /// <summary>
        /// t@C̓{bNXŃL[ꂽƂ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void fileNameBox_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                CallGrep();
                e.Handled = true;
            }
        }

        /// <summary>
        /// ReLXgj[̃Rs[j[NbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void copyContextMenuItem_Click(object sender, EventArgs e)
        {
            if (dataGridView1.SelectedCells.Count == 0)
            {
                MessageUtil.ShowAlert("Rs[ZIĂB");
                return;
            }

            // Nbv{[hɃRs[
            Clipboard.SetDataObject(dataGridView1.SelectedCells[0].Value, true);
        }

        /// <summary>
        /// ʂt@Cɏo̓j[NbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void resultOutputMenuItem_Click(object sender, EventArgs e)
        {
            ShowOutputDialog();
        }

        /// <summary>
        /// ʏo̓_CAO\܂B
        /// </summary>
        private void ShowOutputDialog()
        {
            if (searchResults.Count == 0)
            {
                MessageUtil.ShowAlert("ʂ܂B");
                return;
            }

            OutputDialog dialog = new OutputDialog(this);
            dialog.ShowDialog();
        }

        /// <summary>
        /// ̓GR[fBÕVtgJISNbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void inputSjisMenuItem_Click(object sender, EventArgs e)
        {
            inputSjisMenuItem.Checked = true;
            inputUtf8MenuItem.Checked = false;
            inputEucMenuItem.Checked = false;
            applicationSettings.InputEncoding = Constants.SHIFT_JIS;
        }

        /// <summary>
        /// ̓GR[fBOUTF-8NbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void inputUtf8MenuItem_Click(object sender, EventArgs e)
        {
            inputSjisMenuItem.Checked = false;
            inputUtf8MenuItem.Checked = true;
            inputEucMenuItem.Checked = false;
            applicationSettings.InputEncoding = Constants.UTF8;
        }

        /// <summary>
        /// ̓GR[fBOEUCNbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void inputEucMenuItem_Click(object sender, EventArgs e)
        {
            inputSjisMenuItem.Checked = false;
            inputUtf8MenuItem.Checked = false;
            inputEucMenuItem.Checked = true;
            applicationSettings.InputEncoding = Constants.EUC;
        }

        /// <summary>
        /// o̓GR[fBÕVtgJISNbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void outputSjisMenuItem_Click(object sender, EventArgs e)
        {
            outputSjisMenuItem.Checked = true;
            outputUtf8MenuItem.Checked = false;
            outputEucMenuItem.Checked = false;
            applicationSettings.OutputEncoding = Constants.SHIFT_JIS;
        }

        /// <summary>
        /// o̓GR[fBOUTF-8NbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void outputUtf8MenuItem_Click(object sender, EventArgs e)
        {
            outputSjisMenuItem.Checked = false;
            outputUtf8MenuItem.Checked = true;
            outputEucMenuItem.Checked = false;
            applicationSettings.OutputEncoding = Constants.UTF8;
        }

        /// <summary>
        /// o̓GR[fBOEUCNbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void outputEucMenuItem_Click(object sender, EventArgs e)
        {
            outputSjisMenuItem.Checked = false;
            outputUtf8MenuItem.Checked = false;
            outputEucMenuItem.Checked = true;
            applicationSettings.OutputEncoding = Constants.EUC;
        }

        /// <summary>
        /// ݒ胁j[NbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void settingMenuItem_Click(object sender, EventArgs e)
        {
            SettingDialog dialog = new SettingDialog(this);
            dialog.ShowDialog();
        }

        /// <summary>
        /// ʈꗗ̃Z_uNbNꂽ̏łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void dataGridView1_CellDoubleClick(object sender, DataGridViewCellEventArgs e)
        {
            if (e.RowIndex < 0)
            {
                return;
            }

            string folder = dataGridView1[1, e.RowIndex].Value.ToString();
            string fileName = dataGridView1[0, e.RowIndex].Value.ToString();
            string lineNum = dataGridView1[2, e.RowIndex].Value.ToString();

            if (folder != "")
            {
                string filePath = folder + "\\" + fileName;

                string editorPath = "";

                if (applicationSettings.ExternalEditorPath.Trim() == "")
                {
                    editorPath = "notepad"; // ftHg̓
                }
                else
                {
                    editorPath = applicationSettings.ExternalEditorPath;
                }

                // GfB^ɓn
                string arguments = "";

                if (applicationSettings.ExternalEditorArgs.Trim() == "")
                {
                    arguments = "\"%F\""; // ftHg̓t@C
                }
                else
                {
                    arguments = applicationSettings.ExternalEditorArgs;
                }

                // ̓L[[hu
                arguments = arguments.Replace("%F", filePath); // t@C
                arguments = arguments.Replace("%L", lineNum); // sԍ
                arguments = arguments.Replace("%W", searchStringBox.Items[0].ToString()); // 

                try
                {
                    Process p = new Process();
                    p.StartInfo.FileName = editorPath;
                    p.StartInfo.Arguments = arguments;

                    p.Start();
                }
                catch (Exception)
                {
                    MessageUtil.ShowAlert("OGfB^̋NɎs܂B");
                }

            }
        }

        /// <summary>
        /// Z̓e\鎞ɔCxgɑ΂鏈łB
        /// </summary>
        /// <param name="sender">Cxg𔭐IuWFNg</param>
        /// <param name="e">Cxg</param>
        private void dataGridView1_CellFormatting(object sender, DataGridViewCellFormattingEventArgs e)
        {
            // ẽZ̕`̏ꍇ
            if (dataGridView1.Columns[e.ColumnIndex].Name == "contents" || dataGridView1.Columns[e.ColumnIndex].Name == "e")
            {
                if (e.Value != null)
                {
                    // ^uXy[X4ɕϊ
                    e.Value = e.Value.ToString().Replace("\t", "    ");
                }
            }
        }
	}
}
